Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Dialog.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,12 +6,21 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Dialog.hpp"
-
+#include "Actions/ValueStorage.hpp"
+
+#include "Helpers/Verbose.hpp"
 #include "atom.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Box.hpp"
 
 using namespace std;
@@ -64,4 +73,8 @@
 }
 
+bool Dialog::hasQueries(){
+  return queries.size();
+}
+
 /****************** Query types Infrastructure **************************/
 
@@ -94,6 +107,6 @@
 // Int Queries
 
-Dialog::IntQuery::IntQuery(string title,int *_target, std::string description) :
-    Query(title, description), target(_target)
+Dialog::IntQuery::IntQuery(string title, std::string description) :
+    Query(title, description)
 {}
 
@@ -101,11 +114,23 @@
 
 void Dialog::IntQuery::setResult() {
-  *target = tmp;
-}
-
-// Int Queries
-
-Dialog::BooleanQuery::BooleanQuery(string title,bool *_target, std::string description) :
-    Query(title, description), target(_target)
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Ints Queries
+
+Dialog::IntsQuery::IntsQuery(string title, std::string description) :
+    Query(title, description)
+{}
+
+Dialog::IntsQuery::~IntsQuery() {}
+
+void Dialog::IntsQuery::setResult() {
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Bool Queries
+
+Dialog::BooleanQuery::BooleanQuery(string title,std::string description) :
+    Query(title, description)
 {}
 
@@ -113,11 +138,11 @@
 
 void Dialog::BooleanQuery::setResult() {
-  *target = tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // String Queries
 
-Dialog::StringQuery::StringQuery(string title,string *_target, std::string _description) :
-    Query(title, _description), target(_target)
+Dialog::StringQuery::StringQuery(string title,std::string _description) :
+    Query(title, _description)
 {}
 
@@ -125,11 +150,11 @@
 
 void Dialog::StringQuery::setResult() {
-  *target = tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // Strings Queries
 
-Dialog::StringsQuery::StringsQuery(string title,vector<string> *_target, std::string _description) :
-    Query(title, _description), target(_target)
+Dialog::StringsQuery::StringsQuery(string title,std::string _description) :
+    Query(title, _description)
 {}
 
@@ -137,11 +162,11 @@
 
 void Dialog::StringsQuery::setResult() {
-  *target = tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // Double Queries
 
-Dialog::DoubleQuery::DoubleQuery(string title,double *_target, std::string _description) :
-    Query(title, _description), target(_target)
+Dialog::DoubleQuery::DoubleQuery(string title, std::string _description) :
+    Query(title, _description)
 {}
 
@@ -149,5 +174,17 @@
 
 void Dialog::DoubleQuery::setResult() {
-  *target = tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Doubles Queries
+
+Dialog::DoublesQuery::DoublesQuery(string title, std::string _description) :
+    Query(title, _description)
+{}
+
+Dialog::DoublesQuery::~DoublesQuery() {};
+
+void Dialog::DoublesQuery::setResult() {
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -155,9 +192,7 @@
 // Atom Queries
 
-Dialog::AtomQuery::AtomQuery(string title, atom **_target, std::string _description) :
+Dialog::AtomQuery::AtomQuery(string title, std::string _description) :
     Query(title, _description),
-    tmp(0),
-    target(_target)
-
+    tmp(0)
 {}
 
@@ -165,14 +200,25 @@
 
 void Dialog::AtomQuery::setResult() {
-  *target = tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Atoms Queries
+
+Dialog::AtomsQuery::AtomsQuery(string title, std::string _description) :
+    Query(title, _description),
+    tmp(0)
+{}
+
+Dialog::AtomsQuery::~AtomsQuery() {}
+
+void Dialog::AtomsQuery::setResult() {
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // Molecule Queries
 
-Dialog::MoleculeQuery::MoleculeQuery(string title, molecule **_target, std::string _description) :
+Dialog::MoleculeQuery::MoleculeQuery(string title, std::string _description) :
     Query(title, _description),
-    tmp(0),
-    target(_target)
-
+    tmp(0)
 {}
 
@@ -180,51 +226,64 @@
 
 void Dialog::MoleculeQuery::setResult() {
-  *target = tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Molecules Queries
+
+Dialog::MoleculesQuery::MoleculesQuery(string title, std::string _description) :
+    Query(title, _description),
+    tmp(0)
+{}
+
+Dialog::MoleculesQuery::~MoleculesQuery() {}
+
+void Dialog::MoleculesQuery::setResult() {
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // Vector Queries
 
-Dialog::VectorQuery::VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description) :
+Dialog::VectorQuery::VectorQuery(std::string title,bool _check, std::string _description) :
   Query(title, _description),
-  cellSize(_cellSize),
-  check(_check),
-  target(_target)
-{
-  tmp = new Vector();
-}
+  check(_check)
+{}
 
 Dialog::VectorQuery::~VectorQuery()
-{
-  delete tmp;
-}
+{}
 
 void Dialog::VectorQuery::setResult() {
-  *target = *tmp;
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Vectors Queries
+
+Dialog::VectorsQuery::VectorsQuery(std::string title,bool _check, std::string _description) :
+  Query(title, _description),
+  check(_check)
+{}
+
+Dialog::VectorsQuery::~VectorsQuery()
+{}
+
+void Dialog::VectorsQuery::setResult() {
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // Box Queries
 
-Dialog::BoxQuery::BoxQuery(std::string title, double ** const _cellSize, std::string _description) :
-  Query(title, _description),
-  target(_cellSize)
-{
-    tmp = new double[6];
-}
+Dialog::BoxQuery::BoxQuery(std::string title, std::string _description) :
+  Query(title, _description)
+{}
 
 Dialog::BoxQuery::~BoxQuery()
-{
-  delete[] tmp;
-}
+{}
 
 void Dialog::BoxQuery::setResult() {
-  for (int i=0;i<6;i++) {
-    (*target)[i] = tmp[i];
-  }
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
 // Element Queries
-Dialog::ElementQuery::ElementQuery(std::string title, std::vector<element *> *_target, std::string _description) :
-  Query(title, _description),
-  target(_target)
+Dialog::ElementQuery::ElementQuery(std::string title, std::string _description) :
+  Query(title, _description)
   {}
 
@@ -232,4 +291,15 @@
 
 void Dialog::ElementQuery::setResult(){
-  *target=elements;
-}
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
+// Elements Queries
+Dialog::ElementsQuery::ElementsQuery(std::string title, std::string _description) :
+  Query(title, _description)
+  {}
+
+Dialog::ElementsQuery::~ElementsQuery(){}
+
+void Dialog::ElementsQuery::setResult(){
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Dialog.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -13,8 +13,11 @@
 #include<vector>
 
+#include "Box.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
 class atom;
+class Box;
 class element;
 class molecule;
-class Vector;
 
 
@@ -36,14 +39,20 @@
 
   virtual void queryEmpty(const char *, std::string = "")=0;
-  virtual void queryBoolean(const char *, bool *, std::string = "")=0;
-  virtual void queryInt(const char *, int *, std::string = "")=0;
-  virtual void queryDouble(const char*,double *, std::string = "")=0;
-  virtual void queryString(const char*, std::string *, std::string = "")=0;
-  virtual void queryStrings(const char*, std::vector<std::string> *, std::string = "")=0;
-  virtual void queryAtom(const char*,atom**,std::string = "")=0;
-  virtual void queryMolecule(const char*,molecule**, std::string = "")=0;
-  virtual void queryVector(const char*,Vector *,const double *const,bool, std::string = "")=0;
-  virtual void queryBox(const char*,double ** const, std::string = "")=0;
-  virtual void queryElement(const char*, std::vector<element *> *, std::string = "")=0;
+  virtual void queryBoolean(const char *, std::string = "")=0;
+  virtual void queryInt(const char *, std::string = "")=0;
+  virtual void queryInts(const char *, std::string = "")=0;
+  virtual void queryDouble(const char*, std::string = "")=0;
+  virtual void queryDoubles(const char*, std::string = "")=0;
+  virtual void queryString(const char*, std::string = "")=0;
+  virtual void queryStrings(const char*, std::string = "")=0;
+  virtual void queryAtom(const char*,std::string = "")=0;
+  virtual void queryAtoms(const char*,std::string = "")=0;
+  virtual void queryMolecule(const char*, std::string = "")=0;
+  virtual void queryMolecules(const char*, std::string = "")=0;
+  virtual void queryVector(const char*,bool, std::string = "")=0;
+  virtual void queryVectors(const char*,bool, std::string = "")=0;
+  virtual void queryBox(const char*, std::string = "")=0;
+  virtual void queryElement(const char*, std::string = "")=0;
+  virtual void queryElements(const char*, std::string = "")=0;
 
   virtual bool display();
@@ -51,4 +60,6 @@
   virtual bool checkAll();
   virtual void setAll();
+
+  virtual bool hasQueries();
 
 protected:
@@ -91,5 +102,5 @@
   class BooleanQuery : public Query {
   public:
-    BooleanQuery(std::string title,bool *_target, std::string _description = "");
+    BooleanQuery(std::string title, std::string _description = "");
     virtual ~BooleanQuery();
     virtual bool handle()=0;
@@ -97,11 +108,9 @@
   protected:
     bool tmp;
-  private:
-    bool *target;
   };
 
   class IntQuery : public Query {
   public:
-    IntQuery(std::string title,int *_target, std::string _description = "");
+    IntQuery(std::string title, std::string _description = "");
     virtual ~IntQuery();
     virtual bool handle()=0;
@@ -109,11 +118,20 @@
   protected:
     int tmp;
-  private:
-    int *target;
+  };
+
+  class IntsQuery : public Query {
+  public:
+    IntsQuery(std::string title, std::string _description = "");
+    virtual ~IntsQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    int temp;
+    std::vector<int> tmp;
   };
 
   class DoubleQuery : public Query {
   public:
-    DoubleQuery(std::string title,double *_target, std::string _description = "");
+    DoubleQuery(std::string title, std::string _description = "");
     virtual ~DoubleQuery();
     virtual bool handle()=0;
@@ -121,11 +139,20 @@
   protected:
     double tmp;
-  private:
-    double *target;
+  };
+
+  class DoublesQuery : public Query {
+  public:
+    DoublesQuery(std::string title, std::string _description = "");
+    virtual ~DoublesQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    double temp;
+    std::vector<double> tmp;
   };
 
   class StringQuery : public Query {
   public:
-    StringQuery(std::string title,std::string *_target, std::string _description = "");
+    StringQuery(std::string title, std::string _description = "");
     virtual ~StringQuery();
     virtual bool handle()=0;
@@ -133,11 +160,9 @@
   protected:
     std::string tmp;
-  private:
-    std::string *target;
   };
 
   class StringsQuery : public Query {
   public:
-    StringsQuery(std::string title,std::vector<std::string> *_target, std::string _description = "");
+    StringsQuery(std::string title, std::string _description = "");
     virtual ~StringsQuery();
     virtual bool handle()=0;
@@ -146,11 +171,9 @@
     std::string temp;
     std::vector<std::string> tmp;
-  private:
-    std::vector<std::string> *target;
   };
 
   class MoleculeQuery : public Query {
   public:
-    MoleculeQuery(std::string title, molecule **_target, std::string _description = "");
+    MoleculeQuery(std::string title, std::string _description = "");
     virtual ~MoleculeQuery();
     virtual bool handle()=0;
@@ -158,11 +181,20 @@
   protected:
     molecule *tmp;
-  private:
-    molecule **target;
+  };
+
+  class MoleculesQuery : public Query {
+  public:
+    MoleculesQuery(std::string title, std::string _description = "");
+    virtual ~MoleculesQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    molecule * temp;
+    std::vector<molecule *> tmp;
   };
 
   class AtomQuery : public Query {
   public:
-    AtomQuery(std::string title, atom **_target, std::string _description = "");
+    AtomQuery(std::string title, std::string _description = "");
     virtual ~AtomQuery();
     virtual bool handle()=0;
@@ -170,44 +202,69 @@
   protected:
     atom *tmp;
-  private:
-    atom **target;
+  };
+
+  class AtomsQuery : public Query {
+  public:
+    AtomsQuery(std::string title, std::string _description = "");
+    virtual ~AtomsQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    atom *temp;
+    std::vector<atom *> tmp;
   };
 
   class VectorQuery : public Query {
   public:
-      VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = "");
+      VectorQuery(std::string title,bool _check, std::string _description = "");
       virtual ~VectorQuery();
       virtual bool handle()=0;
       virtual void setResult();
     protected:
-      Vector *tmp;
-      const double *const cellSize;
+      Vector tmp;
       bool check;
-    private:
-      Vector *target;
+  };
+
+  class VectorsQuery : public Query {
+  public:
+      VectorsQuery(std::string title,bool _check, std::string _description = "");
+      virtual ~VectorsQuery();
+      virtual bool handle()=0;
+      virtual void setResult();
+    protected:
+      Vector temp;
+      std::vector<Vector> tmp;
+      bool check;
   };
 
   class BoxQuery : public Query {
   public:
-      BoxQuery(std::string title,double ** const _cellSize, std::string _description = "");
+      BoxQuery(std::string title, std::string _description = "");
       virtual ~BoxQuery();
       virtual bool handle()=0;
       virtual void setResult();
     protected:
-      double *tmp;
-    private:
-      double **target;
+      Box tmp;
   };
 
   class ElementQuery : public Query {
   public:
-    ElementQuery(std::string title, std::vector<element *> *_target, std::string _description = "");
+    ElementQuery(std::string title, std::string _description = "");
     virtual ~ElementQuery();
     virtual bool handle()=0;
     virtual void setResult();
   protected:
-    std::vector<element *> elements;
-  private:
-    std::vector<element *> * const target;
+    const element * tmp;
+  };
+
+  class ElementsQuery : public Query {
+  public:
+    ElementsQuery(std::string title, std::string _description = "");
+    virtual ~ElementsQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    const element *temp;
+    std::vector<const element *> tmp;
   };
 
Index: src/UIElements/MainWindow.cpp
===================================================================
--- src/UIElements/MainWindow.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/MainWindow.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,7 +5,4 @@
 AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
-
-noinst_LIBRARIES = libMolecuilderUI.a
-libMolecuilderUI_a_SOURCES = ${UISOURCE} ${UIHEADER}
 
 VIEWSOURCE = \
@@ -45,6 +42,5 @@
   ${VIEWSOURCE} \
   Dialog.cpp \
-  MainWindow.cpp \
-  UIFactory.cpp
+  MainWindow.cpp
   
 UIHEADER = \
@@ -55,6 +51,5 @@
   ${VIEWHEADER} \
   Dialog.hpp \
-  MainWindow.hpp \
-  UIFactory.hpp
+  MainWindow.hpp
 
 TEXTUISOURCE = \
@@ -80,3 +75,52 @@
   CommandLineUI/CommandLineWindow.hpp
 
+lib_LTLIBRARIES = libMolecuilderUI-@MOLECUILDER_API_VERSION@.la
+libMolecuilderUI_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+libMolecuilderUI_LIBS = \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la
 
+nobase_libMolecuilderUI_include_HEADERS = ${UIHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderUI_@MOLECUILDER_API_VERSION@_la_SOURCES = ${UISOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderUI_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderUI_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(UISOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/UIElements/Menu/ActionMenuItem.cpp
===================================================================
--- src/UIElements/Menu/ActionMenuItem.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/ActionMenuItem.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/DisplayMenuItem.cpp
===================================================================
--- src/UIElements/Menu/DisplayMenuItem.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/DisplayMenuItem.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -16,7 +21,7 @@
 
 DisplayMenuItem::DisplayMenuItem(Menu* _menu, StringView *_view):
-MenuItem('\0',"",_menu),
-view(_view),
-title("")
+  MenuItem('\0',"",_menu),
+  view(_view),
+  title("")
 {
 }
Index: src/UIElements/Menu/Menu.cpp
===================================================================
--- src/UIElements/Menu/Menu.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/Menu.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/MenuItem.cpp
===================================================================
--- src/UIElements/Menu/MenuItem.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/MenuItem.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -18,6 +23,6 @@
  */
 MenuItem::MenuItem(char _trigger, const char* _description,Menu* menu) :
-trigger(_trigger),
-added(false)
+  trigger(_trigger),
+  added(false)
 {
   description = new string(_description);
Index: src/UIElements/Menu/QT4/QTMenu.cpp
===================================================================
--- src/UIElements/Menu/QT4/QTMenu.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/QT4/QTMenu.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Menu/QT4/QTMenu.hpp"
 
 #include <Qt/qaction.h>
+
+#include "Helpers/MemDebug.hpp"
+
 #include "Menu/MenuItem.hpp"
 
Index: src/UIElements/Menu/SubMenuItem.cpp
===================================================================
--- src/UIElements/Menu/SubMenuItem.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/SubMenuItem.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -11,6 +16,6 @@
 
 SubMenuItem::SubMenuItem(char _trigger,const char* _description,Menu* _parent, Menu* _theMenu) :
-MenuItem(_trigger,_description,_parent),
-theMenu(_theMenu)
+  MenuItem(_trigger,_description,_parent),
+  theMenu(_theMenu)
 {
 }
Index: src/UIElements/Menu/TextMenu.cpp
===================================================================
--- src/UIElements/Menu/TextMenu.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/TextMenu.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -113,6 +118,6 @@
 
 TextMenu::LeaveAction::LeaveAction(TextMenu* _menu) :
-Action(nameBase+_menu->getTitle()),
-menu(_menu)
+  Action(nameBase+_menu->getTitle()),
+  menu(_menu)
 {}
 
@@ -126,4 +131,10 @@
   return false;
 }
+
+Dialog* TextMenu::LeaveAction::fillDialog(Dialog *dialog){
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  return dialog;
+}
+
 
 Action::state_ptr TextMenu::LeaveAction::performCall(){
Index: src/UIElements/Menu/TextMenu.hpp
===================================================================
--- src/UIElements/Menu/TextMenu.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/Menu/TextMenu.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,5 +10,5 @@
 
 #include <list>
-#include <ostream>
+#include <iosfwd>
 #include <string>
 
@@ -35,4 +35,6 @@
     bool shouldUndo();
 
+  protected:
+    virtual Dialog* fillDialog(Dialog *dialog);
   private:
     virtual Action::state_ptr performCall();
Index: src/UIElements/QT4/IntQTQuery.ui
===================================================================
--- src/UIElements/QT4/IntQTQuery.ui	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/UIElements/QT4/IntQTQuery.ui	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,68 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>Form</class>
+ <widget class="QWidget" name="Form">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>400</width>
+    <height>300</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Form</string>
+  </property>
+  <widget class="QLabel" name="label">
+   <property name="geometry">
+    <rect>
+     <x>20</x>
+     <y>30</y>
+     <width>59</width>
+     <height>17</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>TextLabel</string>
+   </property>
+  </widget>
+  <widget class="QLineEdit" name="lineEdit">
+   <property name="geometry">
+    <rect>
+     <x>100</x>
+     <y>20</y>
+     <width>113</width>
+     <height>27</height>
+    </rect>
+   </property>
+  </widget>
+  <widget class="QPushButton" name="pushButton">
+   <property name="geometry">
+    <rect>
+     <x>20</x>
+     <y>70</y>
+     <width>92</width>
+     <height>27</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>OK</string>
+   </property>
+  </widget>
+  <widget class="QPushButton" name="pushButton_2">
+   <property name="geometry">
+    <rect>
+     <x>140</x>
+     <y>70</y>
+     <width>92</width>
+     <height>27</height>
+    </rect>
+   </property>
+   <property name="text">
+    <string>Cancel</string>
+   </property>
+  </widget>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>
Index: src/UIElements/QT4/IntsQTQuery.ui
===================================================================
--- src/UIElements/QT4/IntsQTQuery.ui	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/UIElements/QT4/IntsQTQuery.ui	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,151 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>Form</class>
+ <widget class="QWidget" name="Form">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>740</width>
+    <height>444</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>Form</string>
+  </property>
+  <widget class="QWidget" name="horizontalLayoutWidget">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>240</y>
+     <width>421</width>
+     <height>51</height>
+    </rect>
+   </property>
+   <layout class="QHBoxLayout" name="horizontalLayout">
+    <item>
+     <spacer name="horizontalSpacer">
+      <property name="orientation">
+       <enum>Qt::Horizontal</enum>
+      </property>
+      <property name="sizeHint" stdset="0">
+       <size>
+        <width>40</width>
+        <height>20</height>
+       </size>
+      </property>
+     </spacer>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton">
+      <property name="text">
+       <string>OK</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton_2">
+      <property name="text">
+       <string>Cancel</string>
+      </property>
+     </widget>
+    </item>
+   </layout>
+  </widget>
+  <widget class="QWidget" name="verticalLayoutWidget">
+   <property name="geometry">
+    <rect>
+     <x>280</x>
+     <y>0</y>
+     <width>160</width>
+     <height>221</height>
+    </rect>
+   </property>
+   <layout class="QVBoxLayout" name="verticalLayout">
+    <item>
+     <widget class="QLabel" name="label">
+      <property name="text">
+       <string>Enter Integer:</string>
+      </property>
+      <property name="buddy">
+       <cstring>lineEdit</cstring>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QLineEdit" name="lineEdit">
+      <property name="minimumSize">
+       <size>
+        <width>100</width>
+        <height>20</height>
+       </size>
+      </property>
+      <property name="toolTip">
+       <string>Enter an integer and press Add.</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton_3">
+      <property name="enabled">
+       <bool>false</bool>
+      </property>
+      <property name="text">
+       <string>Add</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QPushButton" name="pushButton_4">
+      <property name="enabled">
+       <bool>false</bool>
+      </property>
+      <property name="text">
+       <string>Remove</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <spacer name="verticalSpacer">
+      <property name="orientation">
+       <enum>Qt::Vertical</enum>
+      </property>
+      <property name="sizeHint" stdset="0">
+       <size>
+        <width>20</width>
+        <height>40</height>
+       </size>
+      </property>
+     </spacer>
+    </item>
+   </layout>
+  </widget>
+  <widget class="QWidget" name="verticalLayoutWidget_2">
+   <property name="geometry">
+    <rect>
+     <x>10</x>
+     <y>0</y>
+     <width>261</width>
+     <height>221</height>
+    </rect>
+   </property>
+   <layout class="QVBoxLayout" name="verticalLayout_2">
+    <item>
+     <widget class="QLabel" name="label_2">
+      <property name="text">
+       <string>Current List of Integers:</string>
+      </property>
+     </widget>
+    </item>
+    <item>
+     <widget class="QListWidget" name="listWidget"/>
+    </item>
+   </layout>
+  </widget>
+ </widget>
+ <tabstops>
+  <tabstop>pushButton</tabstop>
+ </tabstops>
+ <resources/>
+ <connections/>
+</ui>
